// -*- mode: C++; -*-

/** @file core.h
 *
 * Functions to initialize the core module.
 */
#ifndef __HORDE_SESSION_CORE_H__
#define __HORDE_SESSION_CORE_H__

#include <string>
#include "horde_namespace.h"

namespace nmstl {
  class io_event_loop; // no need to include nmstl/ioevent, just declare this class...
};

HORDE_NAMESPACE_BEGIN;

/**
 * Initialize the core module. Create and initialize an IMUX packet
 * scheduler of the given type.
 *
 * @return false if an error occurred, or true.
 */
bool init_core(string scheduler_type, nmstl::io_event_loop& ioloop);

HORDE_NAMESPACE_END;

#endif
