// -*- mode: C++; -*-

/**
 * @file raw_io.h
 *
 * Raw I/O handler manager.
 */

#ifndef __TRIBE_RAWIO_H__
#define __TRIBE_RAWIO_H__

#include <nmstl/net>
#include <nmstl/ioevent>

using namespace std;
using namespace nmstl;

void handle_raw_recv(dynbuf& ip_packet);

extern io_event_loop io_loop;

class rawio_udp_iohandler;
class rawio_tcp_iohandler;
class rawio_icmp_iohandler;
class rawio_send_iohandler;

class rawio_handler_group {
 protected:
  rawio_udp_iohandler*  udp_handler;
  //rawio_tcp_iohandler*  tcp_handler;
  rawio_icmp_iohandler* icmp_handler;
  rawio_send_iohandler* send_handler;

 public:
  rawio_handler_group(inet_address& bind_address);
  ~rawio_handler_group();

  void close();

  // sends a packet using the correct raw socket.
  // async send. non-blocking.
  void send_raw(dynbuf& packet);

  // causes raw sockets to handle packets sent to
  // the given address.
  void allow_address(const inet_address& addr);

  // causes raw sockets to ignore packets sent to the
  // given address.
  void ignore_address(const inet_address& addr);
};

#endif
