#!/bin/bash
# usage:
#  - parameter 1: device identifier
#  - parameter 2: IP address
# probably needs to be run as root.

DEVICE=$1
ADDRESS=$2

#echo device:  $DEVICE
#echo address: $ADDRESS

# flag device as being up
/sbin/ifconfig $DEVICE $ADDRESS
/sbin/ifconfig $DEVICE mtu 1496   # required for tcp
/sbin/ifconfig $DEVICE up

# enable routes
echo "Enabling routes through $DEVICE, using source address $ADDRESS"

# Requires that /etc/iproute2/rt_tables has a table defined
# for $DEVICE.

# Requires that the given device be up and running.

# these take care of the outgoing traffic from ppp0
/sbin/ip ro add default scope global dev $DEVICE table $DEVICE
/sbin/ip ru add from $ADDRESS/32 table $DEVICE

# flush the routing cache
/sbin/ip ro flush cache

# iptables firewall might need to be disabled/stopped for this to work...
