// -*- mode: C++; -*-

/**
 * @file tun_manager.h
 *
 * Code to manage local TUN devices.
 */
#ifndef __TRIBE_TUN_MANAGER__
#define __TRIBE_TUN_MANAGER__

#include <nmstl/io>
#include <nmstl/net>
#include <string>

using namespace nmstl;
using namespace std;

class tun_device_iohandler;

typedef void (*tundev_recv_cb)(dynbuf&, inet_address&);

/// create a new device handler
tun_device_iohandler* create_dev_handler(string name, string devaddr, inet_address tunnel_dest_addr, tundev_recv_cb hrecv);

/// destroy and delete a device handler
void destroy_dev_handler(tun_device_iohandler*);

/// route a packet received at tunnel to the right tun device
void route_to_tun_device(dynbuf& packet);

#endif
