#!/bin/bash
#
# builds follower_new
#

set -x

TARGET="tribe_follower_new"

SRC_FILES="follower_new/follower.cc follower_new/ifmanager.cc follower_new/poolman.cc follower_new/pktstealer.cc"
SRC_FILES="$SRC_FILES common/util.cc ../nmstl/internal.cc ../nmstl/debug.cc"

CXX="g++"
CXX_FLAGS="-I. -Icommon -I../nmstl -I/usr/include/libipq"
OBJ_DIR="obj"
LD="g++"
LD_FLAGS="-lstdc++ -lipq -lpthread"

# clean output directory
if [ -e $OBJ_DIR ]
then
    rm -f "$OBJ_DIR/*"
else
    mkdir $OBJ_DIR
fi

# compile
outlist=""
for src in $SRC_FILES
do
  out=`echo $src | sed 's/[.]cc/.o/' | sed 's/[.]c/.o/' | sed 's/.*[/]//'`
  $CXX $CXX_FLAGS $src -c -o $OBJ_DIR/$out
  outlist="$outlist $OBJ_DIR/$out"
done

# link
$LD $outlist $LD_FLAGS -o $TARGET