import os
import sys

PPPD_COMMAND="/usr/sbin/pppd"
IP_COMMAND = "/sbin/ip"    

def system(cmd):
    print "+", cmd
    return os.system(cmd)

def pppd_call(chat):
    """Equivalent to running the command: 'pppd call <chat>' on
       the command line. Returns the (device_id,ip_address) of the new
       interface (e.g. "ppp0","66.6.0.6") or returns (None,None).
       Callers should call wait to make sure this child process has exited."""
    # first spawn the pppd command
    print "+", PPPD_COMMAND + " call " + chat
    pppd_in,pppd_out = os.popen2(PPPD_COMMAND + " call " + chat)

    # then parse pppd's output to see what happened...
    dev = None
    address = None
    success = False
    
    while True:
        
        # TODO: replace the prefix matches with regular expressions.
        x = pppd_out.readline()
        if x == "": # end of file...
            success = False
            break
        
        print x,
        
        prefix = "Using interface "
        if x[:len(prefix)] == prefix:
            dev = x[len(prefix):-1]    # remember interface ID

        prefix = "local  IP address "
        if x[:len(prefix)] == prefix:  # grab the interface's IP
            address = x[len(prefix):-1]

        prefix = "primary   DNS address"
        if x[:len(prefix)] == prefix:  # assume that if we get this far, 
            success = True             # the interface is working
            break

    pppd_out.close()
    pppd_in.close()
    
    # return to caller    
    if success:
        print "PPP session connected: dev=%s, address=%s" % (dev, address)
        return dev,address
    else:
        print "PPP connection failed. looking at /var/log/messages may help determine the cause."
        return None,None

def iproute_enable(dev_id, address):
    """Enables routes through the given device.
       There must be an entry in /etc/iproute2/rt_tables for this to work.
       This step may not be needed depending on the overall configuration
       of the system."""

    print "enabling routes through %s" % dev_id
    
    # these take care of the outgoing traffic from ppp0
    system(IP_COMMAND + " ro add default scope global dev %s table %s" % (dev_id, dev_id))
    system(IP_COMMAND + " ru add from %s/32 table %s" % (address, dev_id))
    # now flush the routing cache
    system(IP_COMMAND + " ro flush cache")

def print_bold(msg):
    print "\033[1;1m%s\033[0m" % msg

